var App = {};  
App.main = {};

const WIDTH  = 620;
const HEIGHT = 320;

const PLAYERGRA = "sozai.png";

var HPbar = 0; 
var HP = null;
var player_info = {
  	x : 0.5*WIDTH ,
	y : 0.9*HEIGHT ,
};

var player = null; 
var playerid;     
var enemies = {}; 

enchant();

// スプライト表示位置の更新用関数
function updatePos1(unit) {
    unit.x += unit.v;

};
function updatePos2(unit) {
    unit.y += unit.v;

};

// プレーヤークラス
Player =Class.create(Sprite, {
    initialize: function(posx, posy, angle) {
        Sprite.call(this, 33, 32);

        this.gamecore = enchant.Core.instance;
        this.image =  this.gamecore.assets[PLAYERGRA];
        this.frame = 2;

        this.x = posx;
        this.y = posy;
        this.angle = angle;
        this.rotation = this.angle;
        this.v = 0;
    },
    onenterframe: function() {  // イベントリスナ，fpsの頻度で呼ばれる
        var input = this.gamecore.input;
        //移動
        if(input.left){
            this.v -= 0.5;
        }
        if(input.right){
            this.v += 0.5;
        }
 

        this.v *= 0.95;  //スピード落とす

        updatePos1(this);  // 表示更新

        // 画面からはみ出たらワープ
        if(this.x < -this.width/2){ this.x = WIDTH - this.width/2;}
        if(this.x > WIDTH-this.width/2){ this.x = -this.width/2;}
    }
});

HP =Class.create(Sprite, {
    initialize: function(posx, posy,num) {
        Sprite.call(this, 33, 32);

        this.gamecore = enchant.Core.instance;
        this.image =  this.gamecore.assets[PLAYERGRA];
        this.frame = 1;
        this.num = num;
        this.x = posx;
        this.y = posy;
        this.v = 0;
    },
    onenterframe: function() {  
        var input = this.gamecore.input;
        if(this.num == HPbar){this.remove()}
    }
});


Enemy = enchant.Class.create(enchant.Sprite, {
    initialize: function(posx, posy, angle, type) {
        enchant.Sprite.call(this, 33, 32);

        this.gamecore = enchant.Core.instance;
        this.type = type;  
        this.image = this.gamecore.assets[PLAYERGRA];
        this.frame = (type === "toxic")? 1 : 0;

        this.x = posx;
        this.y = posy;
        this.angle = angle;
        this.rotation = this.angle;
        this.v = (type === "toxic")? 8 : 5;

    },
    onenterframe: function() {  // イベントリスナ

        updatePos2(this);


        if( this.x < -this.width/2 || this.y < -this.height/2 ||
            this.x > WIDTH-this.width/2 || this.y > HEIGHT-this.height/2) {
            this.remove();
        }

        if( this.type === "apple" ) {
            if ( this.within(player, 20) ) { 
                this.gamecore.score += 1;
                this.remove();
            }
        }
 
        else if ( this.type === "toxic" ) {
            if ( this.within(player, 20) ) { 
                HPbar += 1;
                this.remove();
            }

        }
    },
    remove: function() {
        this.gamecore.rootScene.removeChild(this);
        delete this;
    }
});

// メイン
window.onload = function() {

    var game = new Core(WIDTH, HEIGHT);

    game.fps = 30;
    game.preload(PLAYERGRA);

    game.score = 0; 

    // スタート前の準備
    game.onload = function() {

        var rootScene = game.rootScene;
        var enemy_num = 0;
        var num =0;
        var scoreLabel = new Label();
        scoreLabel.text = 'Score: ' + game.score;
        scoreLabel.moveTo(10, 0);
        rootScene.addChild(scoreLabel);
        

       


        // 自機
        player = new Player(player_info.x, player_info.y, player_info.angle );
        rootScene.addChild( player );
        for(var i=1;i<4;i++){
          HP[num] = new HP(WIDTH*0.1*(10-i),0,i);
          rootScene.addChild( HP[num] );
          num++;
        }
        game.rootScene.on('enterframe', function() {  // game.fpsの頻度で呼ばれる

           if(HPbar==3){
               var gmov1 = new Label();
               gmov1.font = '50px "Arial"';
               gmov1.text = 'GAME OVER';
               gmov1.x = 0.25*WIDTH ;
	       gmov1.y = 0.3*HEIGHT;
               rootScene.addChild(gmov1);

               var gmov2 = new Label();
               gmov2.font = '50px "Arial"';
               gmov2.text = 'REPLAY : F5';
               gmov2.x = 0.25*WIDTH ;
	       gmov2.y = 0.5*HEIGHT;
               rootScene.addChild(gmov2);

                game.stop();}
            scoreLabel.text = 'Score: ' + game.score;  // スコア更新

            if(this.age % 3 == 0) {
                var wx = Math.floor( Math.random() * WIDTH );
            	var wang = Math.floor( Math.random() * 360 );
                if(Math.random() > 0.3){
                enemies[enemy_num] = new Enemy(wx, 0.1* HEIGHT, wang, "toxic");
                rootScene.addChild( enemies[enemy_num] );
                enemy_num++;
                }
                else {
                enemies[enemy_num] = new Enemy(wx, 0.1* HEIGHT, wang, "apple");
                rootScene.addChild( enemies[enemy_num] );
                enemy_num++; 
                }
            }
            
        });

    };

    // イベント待ちループをスタート
    game.start();
};
